grim/guifications2

flow: Created branch 'feature/pidgin3_support'.
feature/pidgin3_support
2013-05-23, Gary Kramlich
dfbfeb1c13be
file isExecutable
flow: Created branch 'feature/pidgin3_support'.
#! /bin/sh
# Guifications - The end-all, be-all notification framework
# Copyright (C) 2003-2007 Gary Kramlich <grim@reaperworld.com>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
###############################################################################
# Usage
###############################################################################
# This script uses a config file that can be used to stash common arguments
# passed to configure or environment variables that need to be set before
# configure is called. The configuration file is a simple shell script that
# gets sourced.
#
# By default, the config file that is used is named 'autogen.args'. This can
# be configured below.
#
# Available options that are handled are as follow:
# ACLOCAL_FLAGS - command line arguments to pass to aclocal
# AUTOCONF_FLAGS - command line arguments to pass to autoconf
# AUTOHEADER_FLAGS - command line arguments to pass to autoheader
# AUTOMAKE_FLAGS - command line arguments to pass to automake flags
# CONFIGURE_FLAGS - command line arguments to pass to configure
# INTLTOOLIZE_FLAGS - command line arguments to pass to intltoolize
# LIBTOOLIZE_FLAGS - command line arguments to pass to libtoolize
#
# Other helpfull notes:
# If you're using a different c compiler, you can override the environment
# variable in 'autogen.args'. For example, say you're using distcc, just add
# the following to 'autogen.args':
#
# CC="distcc"
#
# This will work for any influential environment variable to configure.
###############################################################################
PACKAGE="Guifications"
ARGS_FILE="autogen.args"
set -e
###############################################################################
# Some helper functions
###############################################################################
check () {
CMD=$1
printf "checking for ${CMD}... "
BIN=`which ${CMD}`
if [ x"${BIN}" = x"" ] ; then
printf "not found.\n"
printf "${CMD} is required to build ${PACKAGE}!\n"
exit 1;
fi
echo "${BIN}"
}
run_or_die () { # beotch
CMD=$1
shift
OUTPUT=`mktemp autogen-XXXXXX`
ARGS="${@}"
if [ x"${ARGS}" != x"" ] ; then
ARGS=" ${ARGS}"
fi
printf "running '${CMD}${ARGS}' ... "
${CMD} ${@} >${OUTPUT} 2>&1
if [ $? != 0 ] ; then
echo "failed."
cat ${OUTPUT}
rm -f ${OUTPUT}
exit 1
else
echo "done."
cat ${OUTPUT}
rm -f ${OUTPUT}
fi
}
cleanup () {
rm -f autogen-??????
echo
exit 2
}
###############################################################################
# We really start here, yes, very sneaky!
###############################################################################
trap cleanup 2
FIGLET=`which figlet`
if [ x"${FIGLET}" != x"" ] ; then
${FIGLET} -f small ${PACKAGE}
echo "build system is being generated"
else
echo "autogenerating build system for '${PACKAGE}'"
fi
###############################################################################
# Look for our args file
###############################################################################
printf "checking for ${ARGS_FILE}: "
if [ -f ${ARGS_FILE} ] ; then
printf "found.\n"
printf "sourcing ${ARGS_FILE}: "
. "`dirname "$0"`"/${ARGS_FILE}
printf "done.\n"
else
printf "not found.\n"
fi
###############################################################################
# Check for our required helpers
###############################################################################
check "libtoolize"; LIBTOOLIZE=${BIN};
check "intltoolize"; INTLTOOLIZE=${BIN};
check "aclocal"; ACLOCAL=${BIN};
check "autoheader"; AUTOHEADER=${BIN};
check "automake"; AUTOMAKE=${BIN};
check "autoconf"; AUTOCONF=${BIN};
###############################################################################
# Run all of our helpers
###############################################################################
run_or_die ${LIBTOOLIZE} -c -f --automake ${LIBTOOLIZE_FLAGS}
run_or_die ${INTLTOOLIZE} -c -f --automake ${INTLTOOLIZE_FLAGS}
run_or_die ${ACLOCAL} ${ACLOCAL_FLAGS}
run_or_die ${AUTOHEADER} ${AUTOHEADER_FLAGS}
run_or_die ${AUTOMAKE} -a -c -f --gnu ${AUTOMAKE_FLAGS}
run_or_die ${AUTOCONF} -f ${AUTOCONF_FLAGS}
###############################################################################
# Run configure
###############################################################################
echo "running ./configure ${CONFIGURE_FLAGS} $@"
./configure ${CONFIGURE_FLAGS} $@
exit 0